Mathematical abstract functions

## Classes

class | roboptim::DerivableParametrizedFunction< F >
| Parametrized function with parameter derivative available. More...
class | roboptim::GenericDifferentiableFunction< T >
| Define an abstract derivable function ( ). More...
struct | roboptim::GenericFunctionTraits< T >
| GenericFunction traits. More...
class | roboptim::GenericFunction< T >
| Define an abstract mathematical function ( ). More...
struct | roboptim::GenericFunctionTraits< EigenMatrixDense >
| Trait specializing GenericFunction for Eigen dense matrices. More...
struct | roboptim::GenericFunctionTraits< EigenMatrixSparse >
| Trait specializing GenericFunction for Eigen sparse matrices. More...
class | roboptim::GenericLinearFunction< T >
| Define an abstract linear function. More...
class | roboptim::ParametrizedFunction< F >
| Define an abstract parametrized mathematical function ( ). More...
class | roboptim::GenericQuadraticFunction< T >
| Define an abstract quadratic function. More...
class | roboptim::SumOfC1Squares
| Sum of the squares of differentiable functions. More...
class | roboptim::GenericTwiceDifferentiableFunction< T >
| Define an abstract function which is derivable twice ( ). More...

## Functions

template<typename T >
std::ostream & | roboptim::operator<< (std::ostream &o, const GenericFunction< T > &f)
| Override operator<< to handle function display. More...
| roboptim::GenericFunction< T >::GenericFunction (size_type inputSize, size_type outputSize=1, std::string name=std::string()) throw ()
| Concrete class constructor should call this constructor. More...
virtual | roboptim::GenericFunction< T >::~GenericFunction () throw ()
| Trivial destructor. More...
virtual std::ostream & | roboptim::GenericFunction< T >::print (std::ostream &) const throw ()
| Display the function on the specified output stream. More...

## Variables

static log4cxx::LoggerPtr | roboptim::GenericFunction< T >::logger
| Pointer to function logger (see log4cxx documentation). More...

## Detailed Description

## Function Documentation

template<typename T >

roboptim::GenericFunction< T >::GenericFunction | ( | size_type | inputSize,
|  | size_type | outputSize = `1`,
|  | std::string | name = `std::string ()`
| ) |  |
throw | ( |
| ) |  |

protected

Concrete class constructor should call this constructor.

Parameters

  inputSize | function arity
  outputSize | result size
  name | function's name

template<typename T >

std::ostream & roboptim::operator<< | ( | std::ostream & | o,
|  | const GenericFunction< T > & | f
| ) |  |

Override operator<< to handle function display.

Parameters

  o | output stream used for display
  f | function to be displayed

Returns
  output stream

template<typename T >

std::ostream & roboptim::GenericFunction< T >::print | ( | std::ostream & | o | ) | const
throw | ( |
| ) |  |

virtual

Display the function on the specified output stream.

Parameters

  o | output stream used for display

Returns
  output stream

Reimplemented in roboptim::GenericDifferentiableFunction< T >, roboptim::GenericTwiceDifferentiableFunction< T >, roboptim::NTimesDerivableFunction< 2 >, roboptim::GenericLinearFunction< T >, roboptim::NumericQuadraticFunction, roboptim::GenericNumericLinearFunction< T >, roboptim::GenericQuadraticFunction< T >, roboptim::IdentityFunction, and roboptim::ConstantFunction.

References roboptim::GenericFunction< T >::getName(), and roboptim::indent().

template<typename T >

roboptim::GenericFunction< T >::~GenericFunction | ( |  | ) |
throw | ( |
| ) |  |

virtual

Trivial destructor.

## Variable Documentation

template<typename T>

log4cxx::LoggerPtr roboptim::GenericFunction< T >::logger

static protected

Pointer to function logger (see log4cxx documentation).

Referenced by roboptim::GenericDifferentiableFunction< T >::gradient(), roboptim::GenericTwiceDifferentiableFunction< T >::hessian(), roboptim::GenericDifferentiableFunction< T >::jacobian(), and roboptim::GenericFunction< T >::operator()().